.\"	$NetBSD: ccdconfig.8,v 1.1.2.1 1995/11/11 02:43:33 thorpej Exp $
.\"
.\" Copyright (c) 1995 Jason R. Thorpe.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgment:
.\"	This product includes software developed for the NetBSD Project
.\"	by Jason R. Thorpe.
.\" 4. The name of the author may not be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
.\" BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
.\" LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
.\" AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
.\" OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" $FreeBSD: src/sbin/ccdconfig/ccdconfig.8,v 1.4.2.2 1999/09/05 11:23:53 peter Exp $
.\"
.Dd July 17, 1995
.Dt CCDCONFIG 8
.Os FreeBSD
.Sh NAME
.Nm ccdconfig
.Nd configuration utility for the concatenated disk driver
.Sh SYNOPSIS
.Nm ccdconfig
.Op Fl cv
.Ar ccd
.Ar ileave
.Op Ar flags
.Ar dev
.Op Ar
.Nm ccdconfig
.Fl C
.Op Fl v
.Op Fl f Ar config_file
.Nm ccdconfig
.Fl u
.Op Fl v
.Ar ccd
.Op Ar
.Nm ccdconfig
.Fl U
.Op Fl v
.Op Fl f Ar config_file
.Nm ccdconfig
.Fl g
.Op Fl M Ar core
.Op Fl N Ar system
.Oo
.Ar ccd Oo ...
.Oc
.Oc
.Sh DESCRIPTION
.Nm Ccdconfig
is used to dynamically configure and unconfigure concatenated disk
devices, or ccds.  For more information about the ccd, see
.Xr ccd 4 .
.Pp
The options are as follows:
.Bl -tag -width indent
.It Fl c
Configure a ccd.  This is the default behavior of
.Nm Ns .
.It Fl C
Configure all ccd devices listed in the ccd configuration file.
.It Fl f Ar config_file
When configuring or unconfiguring all devices, read the file
.Pa config_file
instead of the default
.Pa /etc/ccd.conf .
.It Fl g
Dump the current ccd configuration in a format suitable for use as the
ccd configuration file.  If no arguments are specified, every configured
ccd is dumped.  Otherwise, the configuration of each listed ccd is dumped.
.It Fl M Ar core
Extract values associated with the name list from
.Pa core
instead of the default
.Pa /dev/mem .
.It Fl N Ar system
Use
.Ar system
as the kernel instead of the running kernel (as determined from
.Xr getbootfile 3 ).
.It Fl u
Unconfigure a ccd.
.It Fl U
Unconfigure all ccd devices listed the ccd configuration file.
.It Fl v
Cause
.Nm
to be verbose.
.El
.Pp
A ccd is described on the command line and in the ccd configuration
file by the name of the ccd, the interleave factor, the ccd configuration
flags, and a list of one or more devices.  The flags may be represented
as a decimal number, a hexadecimal number, a comma-separated list
of strings, or the word
.Dq none .
The flags are as follows:
.Bd -unfilled -offset indent
CCDF_SWAP		0x01		Interleave should be dmmax
CCDF_UNIFORM	0x02		Use uniform interleave
CCDF_MIRROR	0x04		Support mirroring
CCDF_PARITY	0x08		Support parity (not implemented yet)
.Ed
.Pp
The format in the
configuration file appears exactly as if it were entered on the command line.
Note that on the command line and in the configuration file, the
.Pa flags
argument is optional.
.Bd -unfilled -offset indent
#
# /etc/ccd.conf
# Configuration file for concatenated disk devices
#
.Pp
# ccd           ileave  flags   component devices
ccd0            16      none    /dev/sd2e /dev/sd3e
.Ed
.Pp
.Sh EXAMPLE
The following command, executed from the command line, would configure ccd0
with 4 components (/dev/sd2e, /dev/sd3e, /dev/sd4e, /dev/sd5e), and an
interleave factor of 32 blocks.
.Bd -unfilled -offset indent
# ccdconfig ccd0 32 0 /dev/sd2e /dev/sd3e /dev/sd4e /dev/sd5e
.Ed
.Pp
.Sh FILES
.Bl -tag -width /etc/ccd.conf -compact
.It Pa /etc/ccd.conf
default ccd configuration file
.El
.Sh SEE ALSO
.Xr ccd 4 ,
.Xr rc 8
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 1.0a .
